/* DataBaseType.c generated by valac 0.56.17, the Vala compiler
 * generated from DataBaseType.vala, do not modify */

/*
* Copyright (c) 2011-2018 Alecaddd (http://alecaddd.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alessandro "Alecaddd" Castellani <castellani.ale@gmail.com>
*/

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DATA_BASE_TYPE (data_base_type_get_type ())
#define DATA_BASE_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_BASE_TYPE, DataBaseType))
#define IS_DATA_BASE_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_BASE_TYPE))
#define DATA_BASE_TYPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATA_BASE_TYPE, DataBaseTypeIface))

typedef struct _DataBaseType DataBaseType;
typedef struct _DataBaseTypeIface DataBaseTypeIface;

struct _DataBaseTypeIface {
	GTypeInterface parent_iface;
	gchar* (*connection_string) (DataBaseType* self, GeeHashMap* data);
	gchar* (*show_schema) (DataBaseType* self);
	gchar* (*show_table_list) (DataBaseType* self, const gchar* name);
	gchar* (*edit_table_name) (DataBaseType* self, const gchar* old_table, const gchar* new_table);
	gchar* (*transfer_table) (DataBaseType* self, const gchar* old_database, const gchar* table, const gchar* new_database);
	gchar* (*show_table_structure) (DataBaseType* self, const gchar* table, const gchar* sortby, const gchar* sort);
	gchar* (*show_table_content) (DataBaseType* self, const gchar* table, gint* count, gint* page, const gchar* sortby, const gchar* sort);
	gchar* (*show_table_relations) (DataBaseType* self, const gchar* table, const gchar* database, const gchar* sortby, const gchar* sort);
	gchar* (*create_database) (DataBaseType* self, const gchar* name);
	gchar* (*delete_database) (DataBaseType* self, const gchar* name);
};

VALA_EXTERN GType data_base_type_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataBaseType, g_object_unref)
VALA_EXTERN gchar* data_base_type_connection_string (DataBaseType* self,
                                         GeeHashMap* data);
VALA_EXTERN gchar* data_base_type_show_schema (DataBaseType* self);
VALA_EXTERN gchar* data_base_type_show_table_list (DataBaseType* self,
                                       const gchar* name);
VALA_EXTERN gchar* data_base_type_edit_table_name (DataBaseType* self,
                                       const gchar* old_table,
                                       const gchar* new_table);
VALA_EXTERN gchar* data_base_type_transfer_table (DataBaseType* self,
                                      const gchar* old_database,
                                      const gchar* table,
                                      const gchar* new_database);
VALA_EXTERN gchar* data_base_type_show_table_structure (DataBaseType* self,
                                            const gchar* table,
                                            const gchar* sortby,
                                            const gchar* sort);
VALA_EXTERN gchar* data_base_type_show_table_content (DataBaseType* self,
                                          const gchar* table,
                                          gint* count,
                                          gint* page,
                                          const gchar* sortby,
                                          const gchar* sort);
VALA_EXTERN gchar* data_base_type_show_table_relations (DataBaseType* self,
                                            const gchar* table,
                                            const gchar* database,
                                            const gchar* sortby,
                                            const gchar* sort);
VALA_EXTERN gchar* data_base_type_create_database (DataBaseType* self,
                                       const gchar* name);
VALA_EXTERN gchar* data_base_type_delete_database (DataBaseType* self,
                                       const gchar* name);
static GType data_base_type_get_type_once (void);

gchar*
data_base_type_connection_string (DataBaseType* self,
                                  GeeHashMap* data)
{
	DataBaseTypeIface* _iface_;
#line 26 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 26 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->connection_string) {
#line 26 "../src/Services/Types/DataBaseType.vala"
		return _iface_->connection_string (self, data);
#line 120 "DataBaseType.c"
	}
#line 26 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 124 "DataBaseType.c"
}

gchar*
data_base_type_show_schema (DataBaseType* self)
{
	DataBaseTypeIface* _iface_;
#line 31 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 31 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->show_schema) {
#line 31 "../src/Services/Types/DataBaseType.vala"
		return _iface_->show_schema (self);
#line 139 "DataBaseType.c"
	}
#line 31 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 143 "DataBaseType.c"
}

gchar*
data_base_type_show_table_list (DataBaseType* self,
                                const gchar* name)
{
	DataBaseTypeIface* _iface_;
#line 36 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 36 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->show_table_list) {
#line 36 "../src/Services/Types/DataBaseType.vala"
		return _iface_->show_table_list (self, name);
#line 159 "DataBaseType.c"
	}
#line 36 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 163 "DataBaseType.c"
}

gchar*
data_base_type_edit_table_name (DataBaseType* self,
                                const gchar* old_table,
                                const gchar* new_table)
{
	DataBaseTypeIface* _iface_;
#line 41 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 41 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->edit_table_name) {
#line 41 "../src/Services/Types/DataBaseType.vala"
		return _iface_->edit_table_name (self, old_table, new_table);
#line 180 "DataBaseType.c"
	}
#line 41 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 184 "DataBaseType.c"
}

gchar*
data_base_type_transfer_table (DataBaseType* self,
                               const gchar* old_database,
                               const gchar* table,
                               const gchar* new_database)
{
	DataBaseTypeIface* _iface_;
#line 46 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 46 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->transfer_table) {
#line 46 "../src/Services/Types/DataBaseType.vala"
		return _iface_->transfer_table (self, old_database, table, new_database);
#line 202 "DataBaseType.c"
	}
#line 46 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 206 "DataBaseType.c"
}

gchar*
data_base_type_show_table_structure (DataBaseType* self,
                                     const gchar* table,
                                     const gchar* sortby,
                                     const gchar* sort)
{
	DataBaseTypeIface* _iface_;
#line 51 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 51 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->show_table_structure) {
#line 51 "../src/Services/Types/DataBaseType.vala"
		return _iface_->show_table_structure (self, table, sortby, sort);
#line 224 "DataBaseType.c"
	}
#line 51 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 228 "DataBaseType.c"
}

gchar*
data_base_type_show_table_content (DataBaseType* self,
                                   const gchar* table,
                                   gint* count,
                                   gint* page,
                                   const gchar* sortby,
                                   const gchar* sort)
{
	DataBaseTypeIface* _iface_;
#line 56 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 56 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->show_table_content) {
#line 56 "../src/Services/Types/DataBaseType.vala"
		return _iface_->show_table_content (self, table, count, page, sortby, sort);
#line 248 "DataBaseType.c"
	}
#line 56 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 252 "DataBaseType.c"
}

gchar*
data_base_type_show_table_relations (DataBaseType* self,
                                     const gchar* table,
                                     const gchar* database,
                                     const gchar* sortby,
                                     const gchar* sort)
{
	DataBaseTypeIface* _iface_;
#line 64 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 64 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->show_table_relations) {
#line 64 "../src/Services/Types/DataBaseType.vala"
		return _iface_->show_table_relations (self, table, database, sortby, sort);
#line 271 "DataBaseType.c"
	}
#line 64 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 275 "DataBaseType.c"
}

gchar*
data_base_type_create_database (DataBaseType* self,
                                const gchar* name)
{
	DataBaseTypeIface* _iface_;
#line 72 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 72 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->create_database) {
#line 72 "../src/Services/Types/DataBaseType.vala"
		return _iface_->create_database (self, name);
#line 291 "DataBaseType.c"
	}
#line 72 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 295 "DataBaseType.c"
}

gchar*
data_base_type_delete_database (DataBaseType* self,
                                const gchar* name)
{
	DataBaseTypeIface* _iface_;
#line 77 "../src/Services/Types/DataBaseType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/Services/Types/DataBaseType.vala"
	_iface_ = DATA_BASE_TYPE_GET_INTERFACE (self);
#line 77 "../src/Services/Types/DataBaseType.vala"
	if (_iface_->delete_database) {
#line 77 "../src/Services/Types/DataBaseType.vala"
		return _iface_->delete_database (self, name);
#line 311 "DataBaseType.c"
	}
#line 77 "../src/Services/Types/DataBaseType.vala"
	return NULL;
#line 315 "DataBaseType.c"
}

static void
data_base_type_default_init (DataBaseTypeIface * iface,
                             gpointer iface_data)
{
}

static GType
data_base_type_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DataBaseTypeIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_base_type_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType data_base_type_type_id;
	data_base_type_type_id = g_type_register_static (G_TYPE_INTERFACE, "DataBaseType", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (data_base_type_type_id, G_TYPE_OBJECT);
	return data_base_type_type_id;
}

GType
data_base_type_get_type (void)
{
	static volatile gsize data_base_type_type_id__once = 0;
	if (g_once_init_enter (&data_base_type_type_id__once)) {
		GType data_base_type_type_id;
		data_base_type_type_id = data_base_type_get_type_once ();
		g_once_init_leave (&data_base_type_type_id__once, data_base_type_type_id);
	}
	return data_base_type_type_id__once;
}

